local L = AceLibrary("AceLocale-2.2"):new("Automaton_Invite")
Automaton_Invite = Automaton:NewModule("Invite", "AceEvent-2.0", "AceConsole-2.0", "AceDebug-2.0")
local module = Automaton_Invite

L:RegisterTranslations("enUS", function() return {
    ["Invite"] = true,
} end)

module.description = "Options for sending out party invites."
module.options = {
	keyword = {
		type = 'text',
		name = "Invite text",
		desc = "The text users send to trigger an invite.",
		get = function() return module.db.profile.inviteString end,
		set = function(v) module.db.profile.inviteString = v end,
	},
	case = {
		type = 'toggle',
		name = 'Ignore case',
		desc = "Disable case sensitivity for the invite text",
		get = function() return module.db.profile.ignoreCase end,
		set = function(v) module.db.profile.ignoreCase = v end,
	}
}

function module:OnInitialize()
	self.db = Automaton:AcquireDBNamespace("Invite")
	Automaton:RegisterDefaults('Invite', 'profile', {
		inviteString = "invite",
		ignoreCase = true
	})
	self:RegisterOptions(self.options)
end

function module:OnEnable()
	self:RegisterEvent("CHAT_MSG_WHISPER")
end

function module:CHAT_MSG_WHISPER(text,from)
	local keyword,msg
	local player = from
	if module.db.profile.ignoreCase then
		keyword = string.lower(module.db.profile.inviteString)
		msg = string.lower(text)
	else
		keyword = module.db.profile.inviteString
		msg = text
	end
	if string.find(msg,format("^%s$",keyword)) then
		local acceptFrom = {}
		GuildRoster()

		for i=1,GetNumGuildMembers() do
			local name = GetGuildRosterInfo(i)
			tinsert(acceptFrom,name)
		end

		for i=1,GetNumFriends() do
			local name = GetFriendInfo(i)
			tinsert(acceptFrom,name)
		end

		if foreachi(acceptFrom, function(i,v) if v==player then return true end end) then
			InviteUnit(player)
		end
	end
end